package Razor2::Preproc::Manager;
use Razor2::Preproc::deBase64;
use Razor2::Preproc::deQP;
use Razor2::Preproc::deHTML;
use Razor2::Preproc::deNewline;
use strict;

sub new  {

    return bless { 
        deBase64 => new Razor2::Preproc::deBase64,    
        deQP     => new Razor2::Preproc::deQP,
        deHTML   => new Razor2::Preproc::deHTML,
        deNewline=> new Razor2::Preproc::deNewline,
    }, shift;

}

#
# $bodyref must be Headers\n\r*\nBody
# for this to work.   Cleaned ref to Body returned.
# 
sub preproc {

    my ($self, $bodyref, $dolength) = @_;
    my $lengths = { '1_orig' => length($$bodyref) } if $dolength;

    if ($self->{deBase64}->isit($bodyref)) { 
        $self->{deBase64}->doit($bodyref);
    }
    #$self->log2file($bodyref, "preproc.afta.debase64");
    $lengths->{'2_after_deBase64'} = length($$bodyref) if $dolength;

    my $isQP;
    if ($isQP = $self->{deQP}->isit($bodyref)) { 
        $self->{deQP}->doit($bodyref);
    }
    #$self->log2file($bodyref, "preproc.afta.deQP.$isQP");
    $lengths->{'3_after_deQP'} = length($$bodyref) if $dolength;

    if ($self->{deHTML}->isit($bodyref)) { 
        $self->{deHTML}->doit($bodyref);
    }

    $self->{deNewline}->doit($bodyref);
    #$self->log2file($bodyref, "preproc.afta.deHTML");
    $lengths->{'4_after_deHTML'} = length($$bodyref) if $dolength;

    my ($hdr, $body) = split /\n\r*\n/, $$bodyref, 2;

    $$bodyref = $body;
    $lengths->{'5_after_header_removal'} = length($$bodyref) if $dolength;

    return $lengths;
}


sub log2file {
    my ($self, $msgref, $mailid) = @_;
    my $len = length($$msgref);
    my $fn = "/tmp/.razor.debug.msg.$$.$mailid";
    if (open OUT, ">$fn") {
        print OUT $$msgref;
        close OUT;
    } else {
    }
}


1;


